/**
 * Autogenerated by Avro
 *
 * DO NOT EDIT DIRECTLY
 */
package io.asouquieres.avromodel;

import org.apache.avro.generic.GenericArray;
import org.apache.avro.specific.SpecificData;
import org.apache.avro.util.Utf8;
import org.apache.avro.message.BinaryMessageEncoder;
import org.apache.avro.message.BinaryMessageDecoder;
import org.apache.avro.message.SchemaStore;

/** Legacy Customer model */
@org.apache.avro.specific.AvroGenerated
public class LegacyCustomer extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
  private static final long serialVersionUID = 6866547718316601066L;
  public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"LegacyCustomer\",\"namespace\":\"io.asouquieres.avromodel\",\"doc\":\"Legacy Customer model\",\"fields\":[{\"name\":\"identifier\",\"type\":\"long\"},{\"name\":\"c_name\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"full_address\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"contactDate\",\"type\":{\"type\":\"long\",\"logicalType\":\"timestamp-millis\"}}]}");
  public static org.apache.avro.Schema getClassSchema() { return SCHEMA$; }

  private static SpecificData MODEL$ = new SpecificData();
static {
    MODEL$.addLogicalTypeConversion(new org.apache.avro.data.TimeConversions.TimestampMillisConversion());
  }

  private static final BinaryMessageEncoder<LegacyCustomer> ENCODER =
      new BinaryMessageEncoder<LegacyCustomer>(MODEL$, SCHEMA$);

  private static final BinaryMessageDecoder<LegacyCustomer> DECODER =
      new BinaryMessageDecoder<LegacyCustomer>(MODEL$, SCHEMA$);

  /**
   * Return the BinaryMessageEncoder instance used by this class.
   * @return the message encoder used by this class
   */
  public static BinaryMessageEncoder<LegacyCustomer> getEncoder() {
    return ENCODER;
  }

  /**
   * Return the BinaryMessageDecoder instance used by this class.
   * @return the message decoder used by this class
   */
  public static BinaryMessageDecoder<LegacyCustomer> getDecoder() {
    return DECODER;
  }

  /**
   * Create a new BinaryMessageDecoder instance for this class that uses the specified {@link SchemaStore}.
   * @param resolver a {@link SchemaStore} used to find schemas by fingerprint
   * @return a BinaryMessageDecoder instance for this class backed by the given SchemaStore
   */
  public static BinaryMessageDecoder<LegacyCustomer> createDecoder(SchemaStore resolver) {
    return new BinaryMessageDecoder<LegacyCustomer>(MODEL$, SCHEMA$, resolver);
  }

  /**
   * Serializes this LegacyCustomer to a ByteBuffer.
   * @return a buffer holding the serialized data for this instance
   * @throws java.io.IOException if this instance could not be serialized
   */
  public java.nio.ByteBuffer toByteBuffer() throws java.io.IOException {
    return ENCODER.encode(this);
  }

  /**
   * Deserializes a LegacyCustomer from a ByteBuffer.
   * @param b a byte buffer holding serialized data for an instance of this class
   * @return a LegacyCustomer instance decoded from the given buffer
   * @throws java.io.IOException if the given bytes could not be deserialized into an instance of this class
   */
  public static LegacyCustomer fromByteBuffer(
      java.nio.ByteBuffer b) throws java.io.IOException {
    return DECODER.decode(b);
  }

   private long identifier;
   private java.lang.String c_name;
   private java.lang.String full_address;
   private java.time.Instant contactDate;

  /**
   * Default constructor.  Note that this does not initialize fields
   * to their default values from the schema.  If that is desired then
   * one should use <code>newBuilder()</code>.
   */
  public LegacyCustomer() {}

  /**
   * All-args constructor.
   * @param identifier The new value for identifier
   * @param c_name The new value for c_name
   * @param full_address The new value for full_address
   * @param contactDate The new value for contactDate
   */
  public LegacyCustomer(java.lang.Long identifier, java.lang.String c_name, java.lang.String full_address, java.time.Instant contactDate) {
    this.identifier = identifier;
    this.c_name = c_name;
    this.full_address = full_address;
    this.contactDate = contactDate.truncatedTo(java.time.temporal.ChronoUnit.MILLIS);
  }

  public org.apache.avro.specific.SpecificData getSpecificData() { return MODEL$; }
  public org.apache.avro.Schema getSchema() { return SCHEMA$; }
  // Used by DatumWriter.  Applications should not call.
  public java.lang.Object get(int field$) {
    switch (field$) {
    case 0: return identifier;
    case 1: return c_name;
    case 2: return full_address;
    case 3: return contactDate;
    default: throw new IndexOutOfBoundsException("Invalid index: " + field$);
    }
  }

  private static final org.apache.avro.Conversion<?>[] conversions =
      new org.apache.avro.Conversion<?>[] {
      null,
      null,
      null,
      new org.apache.avro.data.TimeConversions.TimestampMillisConversion(),
      null
  };

  @Override
  public org.apache.avro.Conversion<?> getConversion(int field) {
    return conversions[field];
  }

  // Used by DatumReader.  Applications should not call.
  @SuppressWarnings(value="unchecked")
  public void put(int field$, java.lang.Object value$) {
    switch (field$) {
    case 0: identifier = (java.lang.Long)value$; break;
    case 1: c_name = value$ != null ? value$.toString() : null; break;
    case 2: full_address = value$ != null ? value$.toString() : null; break;
    case 3: contactDate = (java.time.Instant)value$; break;
    default: throw new IndexOutOfBoundsException("Invalid index: " + field$);
    }
  }

  /**
   * Gets the value of the 'identifier' field.
   * @return The value of the 'identifier' field.
   */
  public long getIdentifier() {
    return identifier;
  }


  /**
   * Sets the value of the 'identifier' field.
   * @param value the value to set.
   */
  public void setIdentifier(long value) {
    this.identifier = value;
  }

  /**
   * Gets the value of the 'c_name' field.
   * @return The value of the 'c_name' field.
   */
  public java.lang.String getCName() {
    return c_name;
  }


  /**
   * Sets the value of the 'c_name' field.
   * @param value the value to set.
   */
  public void setCName(java.lang.String value) {
    this.c_name = value;
  }

  /**
   * Gets the value of the 'full_address' field.
   * @return The value of the 'full_address' field.
   */
  public java.lang.String getFullAddress() {
    return full_address;
  }


  /**
   * Sets the value of the 'full_address' field.
   * @param value the value to set.
   */
  public void setFullAddress(java.lang.String value) {
    this.full_address = value;
  }

  /**
   * Gets the value of the 'contactDate' field.
   * @return The value of the 'contactDate' field.
   */
  public java.time.Instant getContactDate() {
    return contactDate;
  }


  /**
   * Sets the value of the 'contactDate' field.
   * @param value the value to set.
   */
  public void setContactDate(java.time.Instant value) {
    this.contactDate = value.truncatedTo(java.time.temporal.ChronoUnit.MILLIS);
  }

  /**
   * Creates a new LegacyCustomer RecordBuilder.
   * @return A new LegacyCustomer RecordBuilder
   */
  public static io.asouquieres.avromodel.LegacyCustomer.Builder newBuilder() {
    return new io.asouquieres.avromodel.LegacyCustomer.Builder();
  }

  /**
   * Creates a new LegacyCustomer RecordBuilder by copying an existing Builder.
   * @param other The existing builder to copy.
   * @return A new LegacyCustomer RecordBuilder
   */
  public static io.asouquieres.avromodel.LegacyCustomer.Builder newBuilder(io.asouquieres.avromodel.LegacyCustomer.Builder other) {
    if (other == null) {
      return new io.asouquieres.avromodel.LegacyCustomer.Builder();
    } else {
      return new io.asouquieres.avromodel.LegacyCustomer.Builder(other);
    }
  }

  /**
   * Creates a new LegacyCustomer RecordBuilder by copying an existing LegacyCustomer instance.
   * @param other The existing instance to copy.
   * @return A new LegacyCustomer RecordBuilder
   */
  public static io.asouquieres.avromodel.LegacyCustomer.Builder newBuilder(io.asouquieres.avromodel.LegacyCustomer other) {
    if (other == null) {
      return new io.asouquieres.avromodel.LegacyCustomer.Builder();
    } else {
      return new io.asouquieres.avromodel.LegacyCustomer.Builder(other);
    }
  }

  /**
   * RecordBuilder for LegacyCustomer instances.
   */
  @org.apache.avro.specific.AvroGenerated
  public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<LegacyCustomer>
    implements org.apache.avro.data.RecordBuilder<LegacyCustomer> {

    private long identifier;
    private java.lang.String c_name;
    private java.lang.String full_address;
    private java.time.Instant contactDate;

    /** Creates a new Builder */
    private Builder() {
      super(SCHEMA$);
    }

    /**
     * Creates a Builder by copying an existing Builder.
     * @param other The existing Builder to copy.
     */
    private Builder(io.asouquieres.avromodel.LegacyCustomer.Builder other) {
      super(other);
      if (isValidValue(fields()[0], other.identifier)) {
        this.identifier = data().deepCopy(fields()[0].schema(), other.identifier);
        fieldSetFlags()[0] = other.fieldSetFlags()[0];
      }
      if (isValidValue(fields()[1], other.c_name)) {
        this.c_name = data().deepCopy(fields()[1].schema(), other.c_name);
        fieldSetFlags()[1] = other.fieldSetFlags()[1];
      }
      if (isValidValue(fields()[2], other.full_address)) {
        this.full_address = data().deepCopy(fields()[2].schema(), other.full_address);
        fieldSetFlags()[2] = other.fieldSetFlags()[2];
      }
      if (isValidValue(fields()[3], other.contactDate)) {
        this.contactDate = data().deepCopy(fields()[3].schema(), other.contactDate);
        fieldSetFlags()[3] = other.fieldSetFlags()[3];
      }
    }

    /**
     * Creates a Builder by copying an existing LegacyCustomer instance
     * @param other The existing instance to copy.
     */
    private Builder(io.asouquieres.avromodel.LegacyCustomer other) {
      super(SCHEMA$);
      if (isValidValue(fields()[0], other.identifier)) {
        this.identifier = data().deepCopy(fields()[0].schema(), other.identifier);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.c_name)) {
        this.c_name = data().deepCopy(fields()[1].schema(), other.c_name);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.full_address)) {
        this.full_address = data().deepCopy(fields()[2].schema(), other.full_address);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.contactDate)) {
        this.contactDate = data().deepCopy(fields()[3].schema(), other.contactDate);
        fieldSetFlags()[3] = true;
      }
    }

    /**
      * Gets the value of the 'identifier' field.
      * @return The value.
      */
    public long getIdentifier() {
      return identifier;
    }


    /**
      * Sets the value of the 'identifier' field.
      * @param value The value of 'identifier'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.LegacyCustomer.Builder setIdentifier(long value) {
      validate(fields()[0], value);
      this.identifier = value;
      fieldSetFlags()[0] = true;
      return this;
    }

    /**
      * Checks whether the 'identifier' field has been set.
      * @return True if the 'identifier' field has been set, false otherwise.
      */
    public boolean hasIdentifier() {
      return fieldSetFlags()[0];
    }


    /**
      * Clears the value of the 'identifier' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.LegacyCustomer.Builder clearIdentifier() {
      fieldSetFlags()[0] = false;
      return this;
    }

    /**
      * Gets the value of the 'c_name' field.
      * @return The value.
      */
    public java.lang.String getCName() {
      return c_name;
    }


    /**
      * Sets the value of the 'c_name' field.
      * @param value The value of 'c_name'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.LegacyCustomer.Builder setCName(java.lang.String value) {
      validate(fields()[1], value);
      this.c_name = value;
      fieldSetFlags()[1] = true;
      return this;
    }

    /**
      * Checks whether the 'c_name' field has been set.
      * @return True if the 'c_name' field has been set, false otherwise.
      */
    public boolean hasCName() {
      return fieldSetFlags()[1];
    }


    /**
      * Clears the value of the 'c_name' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.LegacyCustomer.Builder clearCName() {
      c_name = null;
      fieldSetFlags()[1] = false;
      return this;
    }

    /**
      * Gets the value of the 'full_address' field.
      * @return The value.
      */
    public java.lang.String getFullAddress() {
      return full_address;
    }


    /**
      * Sets the value of the 'full_address' field.
      * @param value The value of 'full_address'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.LegacyCustomer.Builder setFullAddress(java.lang.String value) {
      validate(fields()[2], value);
      this.full_address = value;
      fieldSetFlags()[2] = true;
      return this;
    }

    /**
      * Checks whether the 'full_address' field has been set.
      * @return True if the 'full_address' field has been set, false otherwise.
      */
    public boolean hasFullAddress() {
      return fieldSetFlags()[2];
    }


    /**
      * Clears the value of the 'full_address' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.LegacyCustomer.Builder clearFullAddress() {
      full_address = null;
      fieldSetFlags()[2] = false;
      return this;
    }

    /**
      * Gets the value of the 'contactDate' field.
      * @return The value.
      */
    public java.time.Instant getContactDate() {
      return contactDate;
    }


    /**
      * Sets the value of the 'contactDate' field.
      * @param value The value of 'contactDate'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.LegacyCustomer.Builder setContactDate(java.time.Instant value) {
      validate(fields()[3], value);
      this.contactDate = value.truncatedTo(java.time.temporal.ChronoUnit.MILLIS);
      fieldSetFlags()[3] = true;
      return this;
    }

    /**
      * Checks whether the 'contactDate' field has been set.
      * @return True if the 'contactDate' field has been set, false otherwise.
      */
    public boolean hasContactDate() {
      return fieldSetFlags()[3];
    }


    /**
      * Clears the value of the 'contactDate' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.LegacyCustomer.Builder clearContactDate() {
      fieldSetFlags()[3] = false;
      return this;
    }

    @Override
    @SuppressWarnings("unchecked")
    public LegacyCustomer build() {
      try {
        LegacyCustomer record = new LegacyCustomer();
        record.identifier = fieldSetFlags()[0] ? this.identifier : (java.lang.Long) defaultValue(fields()[0]);
        record.c_name = fieldSetFlags()[1] ? this.c_name : (java.lang.String) defaultValue(fields()[1]);
        record.full_address = fieldSetFlags()[2] ? this.full_address : (java.lang.String) defaultValue(fields()[2]);
        record.contactDate = fieldSetFlags()[3] ? this.contactDate : (java.time.Instant) defaultValue(fields()[3]);
        return record;
      } catch (org.apache.avro.AvroMissingFieldException e) {
        throw e;
      } catch (java.lang.Exception e) {
        throw new org.apache.avro.AvroRuntimeException(e);
      }
    }
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumWriter<LegacyCustomer>
    WRITER$ = (org.apache.avro.io.DatumWriter<LegacyCustomer>)MODEL$.createDatumWriter(SCHEMA$);

  @Override public void writeExternal(java.io.ObjectOutput out)
    throws java.io.IOException {
    WRITER$.write(this, SpecificData.getEncoder(out));
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumReader<LegacyCustomer>
    READER$ = (org.apache.avro.io.DatumReader<LegacyCustomer>)MODEL$.createDatumReader(SCHEMA$);

  @Override public void readExternal(java.io.ObjectInput in)
    throws java.io.IOException {
    READER$.read(this, SpecificData.getDecoder(in));
  }

}










